package name.ianmorgan.canfactory.exam;

import java.util.Date;
import java.util.HashSet;

public class ExamResults {

	private final int[] results;

	private Integer gradeAResults;
	private Integer gradeBResults;
	private Integer gradeCResults;
	private Integer distinctResults;

	public ExamResults(String examCode, Date examDate, int[] results) {
		this.results = results;
	}

	public int numberOfGradeAResults() {
		if (gradeAResults == null) {
			int working = 0;
			for (int i : results) {
				if (i >= 70) {
					working++;
				}
			}
			// NOTE: Atomic assignment after calculations for thread safety.
			gradeAResults = working;
		}
		return gradeAResults;
	}

	public int numberOfGradeBResults() {
		// NOTE: there is obvious pattern here for gradeA,B and C that could
		// be solved really easily with lamdas - or less elegantly with
		// anonymous classes. For just three simple methods its a 50/50 decision.
		if (gradeBResults == null) {
			int working = 0;
			for (int i : results) {
				if (i >= 60 && i < 70) {
					working++;
				}
			}
			gradeBResults = working;
		}
		return gradeBResults;
	}

	public int numberOfGradeCResults() {
		if (gradeCResults == null) {
			int working = 0;
			for (int i : results) {
				if (i >= 50 && i < 60) {
					working++;
				}
			}
			gradeCResults = working;
		}
		return gradeCResults;
	}

	public int numberOfPasses() {
		return numberOfGradeAResults() + numberOfGradeBResults() + numberOfGradeCResults();
	}

	public int numberOfFails() {
		return results.length - numberOfPasses();
	}

	public int numberOfDistinctResults() {
		if (distinctResults == null) {
			HashSet<Integer> working = new HashSet<Integer>(100);
			for (int i : results) {
				working.add(i);
			}
			distinctResults = working.size();
		}
		return distinctResults;
	}
}
