package name.ianmorgan.canfactory.seating;

/**
 * Immutable class to hold seat information.
 * 
 * @author Ian Morgan
 * 
 */
public class Seat {
	// note: 48 bytes (from my quick calculation) on 64 bit JVM
	// could be easily collapsed to single 8 byte bit mask if really
	// / worried about serialization.
	private int quality;
	private SeatType type;
	private boolean available;
	private int seatIndex;

	// note sure from spec if I need to allow for non-numeric seat numbers?
	private String number;

	private SeatRow row;

	// just about reaching the sensible limit for a constructor
	public Seat(SeatRow row, String number, int index, SeatType type, int quality, boolean available) {
		this.row = row;
		this.number = number;
		this.seatIndex = index;
		this.type = type;
		this.quality = quality;
		this.available = available;
	}

	public int getQuality() {
		return quality;
	}

	public SeatType getType() {
		return type;
	}

	public boolean isAvailable() {
		return available;
	}

	public int getIndex() {
		return seatIndex;
	}

	public String getNumber() {
		return number;
	}

	/**
	 * Return the row this seat is in. Bidirectional relationships should be
	 * used sparingly and generally I prefer to leave them out until it becomes
	 * obvious they are useful, but in this case it seems reasonable.
	 * 
	 * @return the row this seat is in.
	 */
	public SeatRow getRow() {
		return row;
	}

}
