package name.ianmorgan.canfactory.seating;

import java.util.ArrayList;

/**
 * A custom list to hold all the seats in row. To be treated as immutable.
 * Simply extends from ArrayList but ideally should be some form of immutable
 * list (which of course Java doesn't have out the box).
 * 
 * @author Ian Morgan
 * 
 */
public class SeatRow extends ArrayList<Seat> {
	private static final long serialVersionUID = 2099064269840969590L;

	private String rowName;
	private int rowIndex;

	public SeatRow(String rowName, int index) {
		this.rowName = rowName;
		this.rowIndex = index;
	}

	/**
	 * @return The displayed name, e.g "A"
	 */
	public String getRowName() {
		return rowName;
	}

	/**
	 * @return The zero based index
	 */
	public int getIndex() {
		return rowIndex;
	}

}
