package name.ianmorgan.canfactory.seating;

import java.util.ArrayList;
import java.util.List;

/**
 * A custom list to hold seat rows with useful navigation and helper methods.
 * Intended to be immutable.
 * 
 * @author Ian Morgan
 * 
 */
public class SeatRows extends ArrayList<SeatRow> {
	private static final long serialVersionUID = -8761281111559979928L;

	public SeatRows(List<SeatRow> rows) {
		super(rows);
	}

	public SeatRow findByName(String rowName) {
		for (SeatRow seatRow : this) {
			if (seatRow.getRowName().equals(rowName)) {
				return seatRow;
			}
		}
		return null;
	}

	/**
	 * @return the number of seats in the widest row.
	 */
	public int getMaxSeatsPerRows() {
		int seats = 0;
		for (SeatRow seatRow : this) {
			if (seatRow.size() > seats) {
				seats = seatRow.size();
			}
		}
		return seats;
	}

}
