package name.ianmorgan.canfactory.seating;

/**
 * Holds the seating plan for section of a cinema or theatre. Should be treated
 * as immutable.
 * 
 * Data structures are relatively light weight (mainly List and primitives for
 * efficient serialization. List are treated as immutable and if very fast
 * performance is required they could be re-implemented as simple arrays
 * 
 * @author Ian Morgan
 * 
 */
public class SeatingPlan {
	private SeatRows rows;
	private String sectionName;

	public SeatingPlan(String sectionName, SeatRows rows) {
		this.sectionName = sectionName;
		this.rows = rows;
	}

	public String getSectionName() {
		return this.sectionName;
	}

	public SeatRows getRows() {
		return this.rows;
	}

}
