package name.ianmorgan.canfactory.seating;

import java.util.ArrayList;
import java.util.List;

public class SeatingPlanFactory {

	public static SeatingPlan create(Object someXmlBean) {
		// TODO: A real implementation !!

		// The domain n model is intended to be immutable, with all data passed
		// via constructors. To keep this constructor clutter minimal, and to
		// make client code simpler, some kind of factory can be useful. As the
		// rules are fixed, there is no need to consider dependency 
		// injection.
		//
		// The general pattern is to parse out all the supplied data and then build
		// from the bottom up, i.e. build the Seat objects first
		//
		// As the model contains bi-directional relationships building a true
		// immutable pattern can be a little tricky. For simplicity, I'd consider 
		// judicious use of package level access.
		//
		
		SeatRow row = new SeatRow("A", 0);
		Seat seat = new Seat(row, "1", 0, SeatType.Normal, 10, true);
		row.add(seat);
		List<SeatRow> rows = new ArrayList<SeatRow>();
		rows.add(row);
		return new SeatingPlan("test", new SeatRows(rows));

	}

}
